/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Octets
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.MapConfig
 *  fire.pb.scene.manager.RoleManager
 *  gnet.link.Onlines
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 */
package fire.pb.scene;

import com.locojoy.base.Octets;
import fire.pb.main.ConfigManager;
import fire.pb.map.MapConfig;
import fire.pb.scene.DynamicScene;
import fire.pb.scene.DynamicTemplate;
import fire.pb.scene.MapInfo;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneFactory;
import fire.pb.scene.StaticScene;
import fire.pb.scene.manager.RoleManager;
import gnet.link.Onlines;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;
import mkio.Protocol;
import org.apache.log4j.Logger;

public class SceneManager {
    public static Logger logger = Logger.getLogger((String)"MAPMAIN");
    private static volatile SceneManager instance;
    private final Map<Integer, StaticScene> staticscenes = new HashMap<Integer, StaticScene>();
    private final Map<Integer, DynamicTemplate> templates = new HashMap<Integer, DynamicTemplate>();
    int curDynamicSceneID = 5000;
    private final Map<Integer, MapInfo> mapInfos = new HashMap<Integer, MapInfo>();

    private SceneManager() {
    }

    public static SceneManager getInstance() {
        if (null == instance) {
            instance = new SceneManager();
        }
        return instance;
    }

    public Scene getSceneByID(long sceneid) {
        int mapid = (int)sceneid;
        if (sceneid == (long)((int)sceneid)) {
            return this.staticscenes.get(mapid);
        }
        DynamicTemplate t = this.getDynamicTemplate(mapid);
        if (t == null) {
            return null;
        }
        DynamicScene s = t.getSceneByID(sceneid);
        if (s != null && !s.isAlive(System.currentTimeMillis())) {
            s.unload();
            return null;
        }
        return s;
    }

    public Map<Integer, StaticScene> getAllStaticScenes() {
        return this.staticscenes;
    }

    public DynamicScene getSceneByMapAndOwner(int mapId, long ownerId) {
        DynamicTemplate t = this.getDynamicTemplateByMapID(mapId);
        if (t == null) {
            return null;
        }
        return t.getSceneByOwnerID(ownerId);
    }

    public void sendAll(Protocol p2) {
        Onlines.getInstance().send(RoleManager.getInstance().getRoles().keySet(), p2);
    }

    public void sendOctetsAll(int ptype, Octets poctets) {
        Onlines.getInstance().sendOctets(RoleManager.getInstance().getRoles().keySet(), ptype, poctets);
    }

    void init() throws Exception {
        TreeMap config = ConfigManager.getInstance().getConf(MapConfig.class);
        for (MapConfig m : config.values()) {
            if (0 == m.dynamic) {
                StaticScene ss = SceneFactory.createStaticScene(m);
                this.mapInfos.put(m.getId(), ss.getMapInfo());
                continue;
            }
            DynamicTemplate dt = SceneFactory.createDynamicTemplate(m);
            this.mapInfos.put(m.getId(), dt.getMapInfo());
        }
    }

    DynamicTemplate getDynamicTemplateByMapID(int mapID) {
        return this.templates.get(mapID);
    }

    void addNewStaticScene(StaticScene scene) {
        this.staticscenes.put(scene.getMapID(), scene);
    }

    public void removeStaticScene(int mapid) {
        this.staticscenes.remove(mapid);
    }

    void addNewTemplate(DynamicTemplate dt) {
        this.templates.put(dt.getMapID(), dt);
    }

    public DynamicTemplate getDynamicTemplate(int mapId) {
        return this.templates.get(mapId);
    }

    public MapInfo getMapInfo(int mapId) {
        return this.mapInfos.get(mapId);
    }
}

